"{ Package: 'jv:smallsense' }"

"{ NameSpace: SmallSense }"

Object subclass:#Position
	instanceVariableNames:'node position position1'
	classVariableNames:''
	poolDictionaries:''
	category:'SmallSense-Core'
!


!Position class methodsFor:'instance creation'!

node: node position: position

    ^self new node: node position: position

    "Created: / 26-11-2011 / 16:22:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Position methodsFor:'accessing'!

node
    ^ node
!

position
    ^ position
! !

!Position methodsFor:'initialization'!

node:nd position: pos

    node := nd.
    position := pos.
    position1 := pos - 1

    "Created: / 26-11-2011 / 16:22:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Position methodsFor:'queries'!

isAfterNode
    ^ node endPosition < position1

    "Created: / 26-11-2011 / 16:24:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isBeforeNode
    ^ position < node startPosition

    "Created: / 26-11-2011 / 16:24:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isInNode
    ^ position1 between:node startPosition and:node endPosition

    "Created: / 26-11-2011 / 16:24:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!Position class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ '$Id: SmallSensePosition.st 7823 2011-11-26 16:55:59Z vranyj1 $'
! !

